@echo OFF
REM
REM Licensed Materials-Property of IBM
REM (C)Copyright IBM Corp 2008
REM All rights reserved
REM US Government Users Restricted Rights
REM Use, duplication, or disclosure restricted
REM by GSA ADP Schedule Contract with IBM Corp
REM
REM  arg1 -  log  -   log file to be used by this script 
REM  arg2 -  instance  -  instance name (for example db2inst2) 
REM  arg3 -  dbname  -  database name
REM  arg4 -  dbbackupdir
REM  arg5 -  dbtimestamp
REM  arg6 -  db stop time (Not used)
REM  REM   Note:  The batch file
REM 	        must be run on the same machine where DB2 server is installed.
REM 		
REM ----------------------------------------------------------------------------

setlocal

%~d0
cd %~p0
cd ..\..\restore

set LOG=%~s1
REM Set DB2INSTANCE environment variable 
set DBINST=%2
set DBNAME=%3
set DBBACKUPDIR=%4
set DBTIMESTAMP=%5
set DBSTOPTIME=%6
set RC=0
set DBRC=0
SET DB2INSTANCE=%DBINST%
SET RESTOREDONE=0
set BACKUP_PENDING_BK=0
REM Db2Stop -force
SET ARCHLOGDIR=%DBBACKUPDIR%\%DBTIMESTAMP%_archd
REM Logging the header information in dbconfig.log file
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
echo Started executing dbtklmrestore.bat >> "%LOG%" 
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
SET TRANSLOGDRIVE=C:
if not exist %SYSTEMDRIVE%\tklmV2properties\db2srcit.txt goto nosrcit

for /f "tokens=1,2,3 delims==" %%a in (%SYSTEMDRIVE%\tklmV2properties\db2srcit.txt) do (

  if "%%a"=="INSTANCEHOME" set TRANSLOGDRIVE=%%b
  if "%%a"=="DB2INSTALLDIR" set DB2DIR=%%b
  )

:nosrcit
echo %TRANSLOGDRIVE% >> "%LOG%"

REM directory where scripts and response files have been written
set CURRENT_DIR=.
REM copy %DBBACKUPDIR%\*.001 c:\temp\save
mkdir %ARCHLOGDIR%

echo db2 stop database manager force >> "%LOG%"
db2 stop database manager force

call rmdir /s /q "%TRANSLOGDRIVE%\sklmdbarchive\"
mkdir %TRANSLOGDRIVE%\sklmdbarchive
echo db2 start database manager >> "%LOG%"
db2 start database manager

echo db2 list applications >> "%LOG%"
db2 list applications >> "%LOG%"

echo db2 drop db %DBNAME% >> "%LOG%"
db2 drop db %DBNAME% >> "%LOG%"
set RC=%ERRORLEVEL%

echo FINDSTR  /b  SQL1013N %LOG% >> "%LOG%"
FINDSTR  /b  "SQL1013N" "%LOG%"

set DBRC=%ERRORLEVEL%

if %DBRC% EQU 0 set RC=0
if %RC% LSS 0 goto ERROR 
if %RC% LSS 4 set RC=0 
if not %RC%==0 goto ERROR



echo db2 restore db %DBNAME% from %DBBACKUPDIR% TAKEN AT %DBTIMESTAMP%  WITHOUT PROMPTING >> "%LOG%"
db2 restore db %DBNAME% from %DBBACKUPDIR% TAKEN AT %DBTIMESTAMP% WITHOUT PROMPTING >> "%LOG%"

set RC=%ERRORLEVEL%
if %RC% LSS 0 goto ERROR
if %RC% LSS 4 set RC=0 
if not %RC%==0 goto ERROR
set RESTOREDONE=1


echo db2 restore db %DBNAME% logs from %DBBACKUPDIR% logtarget %ARCHLOGDIR% >> "%LOG%"
db2 restore db %DBNAME% logs  from %DBBACKUPDIR% logtarget %ARCHLOGDIR% >> "%LOG%"


echo db2 stop database manager force >> "%LOG%"
db2 stop database manager force
echo db2 start database manager >> "%LOG%"
db2 start database manager

ECHO "DB2 ROLLFORWARD DB %DBNAME% TO END OF Logs and complete overflow log path (%ARCHLOGDIR%)" >> "%LOG%" 
db2 ROLLFORWARD DB %DBNAME%  TO END OF LOGS AND COMPLETE OVERFLOW log path (%ARCHLOGDIR%) >> "%LOG%" 

REM Add NORETRIEVE so that DB2 will not look for additional logs in the LOGARCHMETH1 directory
REM ECHO "DB2 ROLLFORWARD DB %DBNAME% TO END OF LOGS OVERFLOW log path (%ARCHLOGDIR%) NORETRIEVE" >> "%LOG%" 
REM DB2 ROLLFORWARD DB %DBNAME% TO END OF LOGS OVERFLOW log path (%ARCHLOGDIR%) NORETRIEVE >> "%LOG%" 

REM ECHO "DB2 ROLLFORWARD DB %DBNAME% COMPLETE" >> "%LOG%" 
REM DB2 ROLLFORWARD DB %DBNAME% COMPLETE>> "%LOG%" 

set RC=%ERRORLEVEL%
if %RC% LSS 0 goto ERROR
if %RC% LSS 4 set RC=0 
if not %RC%==0 goto ERROR
set ROLLFORWD=1

echo db2 stop database manager force >> "%LOG%"
db2 stop database manager force
echo db2 start database manager >> "%LOG%"
db2 start database manager

REM Bind the Schema to the database. This is done in case a DB2 PTF is put on the machine that
REM does not match the DB2 version that the backup was taken on.
if "%DB2DIR%"=="" goto END
echo db2 connect to %DBNAME% >> "%LOG%"
db2 connect to %DBNAME% >> "%LOG%"

echo db2 bind '%DB2DIR%bnd\db2schema.bnd' blocking all grant public sqlerror continue >> "%LOG%"
db2 bind '%DB2DIR%bnd\db2schema.bnd' blocking all grant public sqlerror continue >> "%LOG%"

goto END

:ERROR

REM NO SPECIAL PROCESSING NEEDED
goto END

:END

REM DEL /F /S /Q %ARCHLOGDIR%
RMDIR /S /Q %ARCHLOGDIR%


echo Return=%RC%
if %RC%==0 echo Return=%RC% >> "%LOG%"
if %RC% neq 0 echo Return %RC% >> "%LOG%"


echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
exit %RC%
endlocal
